freeslot("SPR_BCHR","S_BULLETCHARGE","SPR_BGOT","S_BULLETRETICLE")
states[S_BULLETCHARGE] = {SPR_BCHR,FF_SEMIBRIGHT|FF_ANIMATE,35,nil,F,6,S_NULL}
states[S_BULLETRETICLE] = {SPR_BGOT,FF_SEMIBRIGHT|FF_TRANS20,35,nil,0,0,S_NULL}

freeslot("S_PHOENIX_AIRDASH", "S_PHOENIX_SWIMDASH", "S_PHOENIX_BDCHARGE")

states[S_PHOENIX_AIRDASH] = {
		sprite = SPR_PLAY,
		frame = SPR2_BNCE,
		var1 = 0,
		var2 = 0,
		tics = 16,
		nextstate = S_PLAY_FALL
}

states[S_PHOENIX_BDCHARGE] = {
		sprite = SPR_PLAY,
		frame = SPR2_LAND,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_BDCHARGE
}

states[S_PHOENIX_SWIMDASH] = {
		sprite = SPR_PLAY,
		frame = SPR2_SWIM,
		var1 = 0,
		var2 = 0,
		tics = 18,
		nextstate = S_PLAY_ROLL
}

local SKIN = "nilskin"

local function ChecknBust(mo, sec, spinbust)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    if (fof.flags & FF_STRONGBUST) and (spinbust == true) continue end -- Is it too strong?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

   if (mo.player) and (mo.player.speed < mo.player.runspeed/3) continue end

    EV_CrumbleChain(fof) -- Crumble
  end
end

--FixedLerp
local function FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end


addHook("AbilitySpecial", function(player)
	if not (player.valid and player.mo and player.mo.valid) then return end
	if player.mo.skin ~= SKIN then return end
	
	if not ((player.pflags&PF_THOKKED)
	and (player.dschargestate ~= 1)
	and not (player.mo.eflags&MFE_UNDERWATER))
	and (player.dschargestate < 3 and player.dsp_batterydashst ~= 3)
	and not player.gotcrystal
	and not (player.charability == CA_NONE and not player.dschargestate)
		player.mun_starthold = TICRATE * 18/21
		player.mo.state = S_PHOENIX_BDCHARGE
		player.pflags = $|PF_THOKKED//|PF_FORCESTRAFE
		player.mo.drawangle = player.mo.angle
		player.chargeaiming = (player.ds_freeaim2) and player.aiming or 0
		
		if player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0
			if player.speed <= 40*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, max(player.speed + FRACUNIT*10, FRACUNIT*12))
			else
				P_InstaThrust(player.mo, player.mo.angle, max(player.speed, FRACUNIT*12))
			end
		end
		
		if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
			P_KillMobj(player.mun_chargeoverlay)
		end
		local o = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_OVERLAY)
		o.state = S_BULLETCHARGE
		o.target = player.mo
		o.color = player.mo.color
		player.mun_chargeoverlay = o
		
		S_StartSound(player.mo,sfx_spndsh)
		player.dontdothemove = 0
	end
	return true
end)

local function SMFMteleport(mobj,newmobj,zoffs,gravflip)
	if gravflip --shut up!
		if (mobj.eflags & MFE_VERTICALFLIP)
			newmobj.eflags = $|MFE_VERTICALFLIP
			newmobj.flags2 = $|MF2_OBJECTFLIP
		else
			newmobj.eflags = $&~MFE_VERTICALFLIP
			newmobj.flags2 = $&~MF2_OBJECTFLIP
		end
	end

	if (mobj.eflags & MFE_VERTICALFLIP)
		local elementheight = FixedMul(newmobj.info.height,mobj.scale)
		return (mobj.z + mobj.height - zoffs - elementheight)
	else
		return mobj.z + zoffs
	end
end

addHook("PlayerThink", function(player)
	if not (player.valid and player.mo and player.mo.valid) then return end
	if player.mo.skin ~= SKIN then return end
  local mo = player.mo
	
	player.mun_starthold = $ or 0
	player.mun_dashstop = $ or 0
	
	if player.playerstate == PST_REBORN
		player.mun_starthold = 0
		player.mun_dashstop = 0
		if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
			P_KillMobj(player.mun_chargeoverlay)
			player.mun_chargeoverlay = nil
		end
		if player.mun_reticle and player.mun_reticle.valid
			P_KillMobj(player.mun_reticle)
			player.mun_reticle = nil
		end
	end

		if player.mo.state == S_DOTHATADLUA
			player.mo.state = S_PLAY_ROLL
			
			if player.speed > 7*FRACUNIT or player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*8
				
				if not (player.mo.eflags&MFE_UNDERWATER)
					if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
						player.mo.state = S_PHOENIX_AIRDASH
						
						player.pflags = $|PF_SPINNING|PF_THOKKED


						if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*2
							player.mo.sprite2 = SPR2_FLY
						end
					
						if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*8 and (player.speed <= 9*FRACUNIT or not player.speed)
							player.mo.sprite2 = SPR2_FIRE
						end
						player.mo.frame = 0
					end
				else
					
					if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
						player.mo.state = S_PHOENIX_SWIMDASH
					
						if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*10
							player.mo.sprite2 = SPR2_SPNG
						end
						player.mo.frame = 0
					end
				end
			end
			player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_BUST|STR_SPIKE|STR_GUARD|STR_ATTACK
		end
	
	if player.mun_starthold
		player.mun_starthold = max($-1,0)
		if P_IsObjectOnGround(player.mo) or P_PlayerInPain(player)
		or player.powers[pw_carry] or player.playerstate ~= PST_LIVE
		or player.mo.state ~= S_PHOENIX_BDCHARGE
			player.mun_starthold = 0
			player.aiming = (player.ds_freeaim2 == 0) and $ or 0
			if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
				P_KillMobj(player.mun_chargeoverlay)
				player.mun_chargeoverlay = nil
			end
			if player.mun_reticle and player.mun_reticle.valid
				P_KillMobj(player.mun_reticle)
				player.mun_reticle = nil
			end
			return
		end

		player.mo.momx = FixedMul($, 92*FRACUNIT/100)
		player.mo.momy = FixedMul($, 92*FRACUNIT/100)
		player.mo.momz = FixedMul($, 75*FRACUNIT/90)
		if abs(player.mo.momz) <= FRACUNIT
			player.mo.momz = $ * 3/4
		end
		
		local dir = min((250*player.mo.scale/TICRATE)*(TICRATE-player.mun_starthold), 250*player.mo.scale)
		if not player.mun_reticle
			local rx = P_ReturnThrustX(nil,player.mo.angle,FixedMul(dir,cos(player.chargeaiming*P_MobjFlip(player.mo))))
			local ry = P_ReturnThrustY(nil,player.mo.angle,FixedMul(dir,cos(player.chargeaiming*P_MobjFlip(player.mo))))
			local rz = FixedMul(dir,sin(player.chargeaiming*P_MobjFlip(player.mo)))
			
			player.mun_reticle = P_SpawnMobjFromMobj(player.mo,rx,ry,rz,MT_PARTICLE)
			local ret = player.mun_reticle
			ret.state = S_BULLETRETICLE
			ret.momx = player.mo.momx
			ret.momy = player.mo.momy
			ret.momz = player.mo.momz
			ret.drawonlyforplayer = player
			ret.fuse = TICRATE
		elseif player.mun_reticle and player.mun_reticle.valid
			local ret = player.mun_reticle
			
			local rx = player.mo.x + P_ReturnThrustX(nil,player.mo.angle,FixedMul(dir,cos(player.chargeaiming*P_MobjFlip(player.mo))))
			local ry = player.mo.y + P_ReturnThrustY(nil,player.mo.angle,FixedMul(dir,cos(player.chargeaiming*P_MobjFlip(player.mo))))
			local sz = FixedMul(dir,sin(player.chargeaiming*P_MobjFlip(player.mo)))
			local rz = SMFMteleport(player.mo,ret,sz,true)
			
			P_MoveOrigin(ret,rx,ry,rz)
			
			ret.state = S_BULLETRETICLE
			ret.momx = player.mo.momx
			ret.momy = player.mo.momy
			ret.momz = player.mo.momz
			ret.drawonlyforplayer = player
			ret.fuse = 2
		end
		
		player.drawangle = player.mo.angle
		player.pflags = $|PF_JUMPED
		
		//if (player.cmd.buttons & BT_CUSTOM1)
	   //player.mun_usedspin = true
   //elseif not (player.mun_usedspin)
     player.aimadd = ((player.pflags & PF_FLIPCAM) and P_MobjFlip(player.mo) <= -1) and (ANG1*player.cmd.forwardmove/8) or -(ANG1*player.cmd.forwardmove/8)

     if player.ds_freeaim2 >= 1
      player.chargeaiming = player.aiming
     end

     if player.ds_freeaim2 ~= 1 and player.mun_starthold <= (TICRATE * 18/21) - 5
      if not player.ds_freeaim2
      player.chargeaiming = (player.dspfreeaim == 1) and $ - player.aimadd or $ + player.aimadd
      else
      player.aiming = (player.dspfreeaim == 1) and $ - player.aimadd or $ + player.aimadd
      player.chargeaiming = player.aiming
      end
     end

     player.chargeaiming = max(-ANGLE_90+1, min(ANGLE_90-1, $))
			
			if (player.pflags & PF_ANALOGMODE)
				player.resetanalog = true
				player.drawangle = player.mo.angle
				player.mo.angle = player.cmd.angleturn << 16
				player.pflags = $ & ~PF_ANALOGMODE
			end
   //else
    
		
		if (player.resetanalog and player.resetanalog == true)
			player.mo.angle = $-(ANG1*player.cmd.sidemove/5) --L Stick controls
		end
		//end
		
		if (player.cmd.buttons & BT_SPIN) //and not (player.pflags&PF_SPINDOWN)
			player.mun_dashstop = 0
			player.mun_starthold = 0
     player.chargeaiming = 0
     player.aiming = (player.ds_freeaim2 == 0) and $ or 0
			
			player.dsp_batterydashst = 3
     if not (player.pflags&PF_SPINDOWN)
     player.dschargestate = 0
     end
			//S_StartSound(player.mo, sfx_airdsh)
			P_SetObjectMomZ(player.mo, -FRACUNIT*18, false)
			player.mo.state = S_PHOENIX_SA2BOUNCE
			S_StopSoundByID(player.mo, sfx_spndsh)
			player.dsp_batterydashti = TICRATE*6/3
			
			if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
				P_KillMobj(player.mun_chargeoverlay)
				player.mun_chargeoverlay = nil
			end
			if player.mun_reticle and player.mun_reticle.valid
				P_KillMobj(player.mun_reticle)
				player.mun_reticle = nil
			end
			if (player.resetanalog and player.resetanalog == true)
				player.pflags = $|PF_ANALOGMODE
				player.resetanalog = false
			end
		end
		
		if not (player.cmd.buttons & BT_JUMP)
			player.mun_starthold = 1
		end
		
		if player.mun_starthold == 1
			player.mo.state = S_PLAY_ROLL
			player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_BUST|STR_SPIKE|STR_GUARD|STR_ATTACK
			local spd = (player.mo.eflags&MFE_UNDERWATER) and 72*player.mo.scale/2 or 140*player.mo.scale/2
			player.mo.state = (player.mo.eflags&MFE_UNDERWATER) and S_PHOENIX_SWIMCURL_A or S_PHOENIX_ADCURL_A
			player.slowit_speed = (player.powers[pw_sneakers] or player.powers[pw_super]) and player.truspeed*9/6 or max(player.normalspeed * 50/36, player.truspeed * 9/7) //lowest speed we wanna slow down to
	 
			local xyspd = max(FixedMul(spd,cos(player.chargeaiming*P_MobjFlip(player.mo))), 0)
			local zspd = (player.powers[pw_shield] == SH_WHIRLWIND or player.powers[pw_shield] == SH_ATTRACT or player.powers[pw_shield] == SH_THUNDERCOIN) and FixedMul(spd * 65/70, sin(player.chargeaiming*P_MobjFlip(player.mo))) or FixedMul(spd * 50/70,sin(player.chargeaiming*P_MobjFlip(player.mo)))
			player.mun_dashstop = (player.mo.eflags&MFE_UNDERWATER) and 18 or 9
			player.mun_starthold = 0
			
			player.pflags = $ & ~PF_STARTJUMP
			
			for i = 0,5
				local di = (140*player.mo.scale/6)*i
				
				local rx = P_ReturnThrustX(nil,player.mo.angle,FixedMul(di,cos(player.chargeaiming*P_MobjFlip(player.mo))))
				local ry = P_ReturnThrustY(nil,player.mo.angle,FixedMul(di,cos(player.chargeaiming*P_MobjFlip(player.mo))))
				local rz = FixedMul(di,sin(player.chargeaiming)) * P_MobjFlip(player.mo)
			
				local d = P_SpawnGhostMobj(player.mo) //P_SpawnMobjFromMobj(player.mo,rx,ry,rz,player.thokitem)
				d.color = player.mo.color
       d.state = S_THOK
				d.scale = 2*player.mo.scale/3 + (player.mo.scale/6)*i
				d.destscale = d.scale/2
       //d.tics = 13
				d.frame = TR_TRANS70|A
			end
			if player.mun_chargeoverlay and player.mun_chargeoverlay.valid
				P_KillMobj(player.mun_chargeoverlay)
				player.mun_chargeoverlay = nil
			end
			if player.mun_reticle and player.mun_reticle.valid
				P_KillMobj(player.mun_reticle)
				player.mun_reticle = nil
			end
			if (player.resetanalog and player.resetanalog == true)
				player.pflags = $|PF_ANALOGMODE
				player.resetanalog = false
			end
			
			
			P_InstaThrust(player.mo,player.mo.angle,xyspd + player.speed/6)
			P_SetObjectMomZ(player.mo,zspd)
			
			
			/*if not (player.mo.eflags&MFE_UNDERWATER)
				if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
					player.mo.state = S_PHOENIX_AIRDASH
					

					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*5
						player.mo.sprite2 = SPR2_FLY
					end
				
					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*57
						player.mo.sprite2 = SPR2_FIRE
					end
					player.mo.frame = 0
				end
			else
				
				if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
					player.mo.state = S_PHOENIX_SWIMDASH
				
					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*32
						player.mo.sprite2 = SPR2_FIRE
					end
					player.mo.frame = 0
				end
			end*/

			
			S_StartSound(player.mo, sfx_zoom)
			S_StartSound(player.mo, sfx_airdsh)
			S_StartSound(player.mo, sfx_s3k45)
			//if player.mun_usedspin or player.dspfreeaim ~= 1
				player.chargeaiming = 0
       player.aiming = (player.ds_freeaim2 == 0) and $ or 0
				//player.mun_usedspin = false
			//end
		end
  elseif (player.resetanalog and player.resetanalog == true)
		player.pflags = $|PF_ANALOGMODE
		player.resetanalog = false
	end

	if player.mun_dashstop
		player.mun_dashstop = max($-1,0)
		if player.mo.state == S_PLAY_SPRING or (player.mo.GSgrind ~= nil and player.mo.GSgrind.grinding ~= nil and player.mo.GSgrind.grinding > 0) or player.powers[pw_carry]
			player.mun_dashstop = 0
			player.powers[pw_strong] = STR_NONE
			return
		end
		
		if (player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)
			player.mun_dashstop = 0
			player.powers[pw_strong] = STR_NONE
			ChecknBust(player.mo, player.mo.subsector.sector)
			
			if (player.cmd.buttons&BT_SPIN)
				player.pflags = $|PF_SPINNING & ~(PF_THOKKED)
				P_InstaThrust(player.mo, player.mo.angle, player.speed-player.thrustfactor)
				S_StartSound(player.mo,sfx_zoom)
				player.mo.state = S_PLAY_ROLL
			else
				if ((player.pflags&PF_STARTJUMP) or (player.cmd.buttons&BT_JUMP))
					S_StartSoundAtVolume(player.mo, sfx_dspbnc, 170)
					P_SetObjectMomZ(player.mo, (player.mo.eflags&MFE_UNDERWATER) and FixedMul(5*FRACUNIT, player.mo.scale) or FixedMul(9*FRACUNIT, player.mo.scale))
				else
					S_StartSoundAtVolume(player.mo, sfx_bounc1, 175)
				end
				
				player.mo.momx = $ - $/7
				player.mo.momy = $ - $/7
				
				player.pflags = ((player.pflags&PF_STARTJUMP) or (player.cmd.buttons&BT_JUMP)) and $|PF_JUMPED|PF_STARTJUMP & ~(PF_SPINNING|PF_THOKKED) or $|PF_JUMPED|PF_STARTJUMP|PF_THOKKED & ~(PF_SPINNING)
				P_InstaThrust(player.mo, player.mo.angle, player.speed-player.thrustfactor)
				P_SetObjectMomZ(player.mo, max(FRACUNIT*6, FRACUNIT*4 + player.mo.momz*P_MobjFlip(player.mo)), false)
				player.mo.state = S_PLAY_ROLL
			end
		end
		
		if player.mun_dashstop == 1 //and player.mo.state == S_PLAY_ROLL
			//player.mo.state = S_PLAY_FALL
			player.powers[pw_strong] = $ & ~(STR_GUARD|STR_BUST|STR_SPIKE|STR_SPRING)
		end
		
		/*if player.mo.state == S_PLAY_ROLL
		local t = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
		t.color = SKINCOLOR_THUNDEROVERLAY //player.mo.color
		t.scale = player.mo.scale
		t.destscale = t.scale/2
		else
		local t = P_SpawnGhostMobj(player.mo)
		t.color = SKINCOLOR_THUNDEROVERLAY //player.mo.color
		t.scale = player.mo.scale
		t.fuse = 4
		t.colorized = true
		end*/

   for i = 0, 9
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(mo)
				local tx = FixedLerp(mo.x,mo.previousx,percent)
				local ty = FixedLerp(mo.y,mo.previousy,percent)
				local tz = FixedLerp(mo.z + 3*FRACUNIT,mo.previousz + 4*FRACUNIT,percent)
				P_MoveOrigin(trail, tx, ty, tz - 7 * FRACUNIT)
				trail.fuse = 13
				trail.state = S_THOK
				trail.scalespeed = FRACUNIT/12
				trail.scale = (FRACUNIT * 5/6) - (i * FRACUNIT/120)
				trail.destscale = 0
				trail.frame = TR_TRANS70|A
		   //trail.color = SKINCOLOR_THUNDEROVERLAY

       if trail.state ~= S_THOK
       trail.colorized = true
       end
				//trail.color = SKINCOLOR_BLUE
			end
		
		if (player.mo.state == S_PHOENIX_SWIMDASH
		and player.mun_dashstop <= 14 and player.mun_dashstop >= 12
		or player.mun_dashstop <= 5 and player.mun_dashstop >= 3)
			if player.speed > player.slowit_speed
				player.mo.momx = (player.mo.eflags&MFE_UNDERWATER) and $ - $/9 or $ - $/7
				player.mo.momy = (player.mo.eflags&MFE_UNDERWATER) and $ - $/9 or $ - $/7
			end

			if not (player.mo.eflags&MFE_UNDERWATER)
				player.mo.momz = (player.mo.momz * P_MobjFlip(player.mo) < -FRACUNIT*2) and $ - $/6 or $ - $/3 //- P_GetMobjGravity(player.mo)
			end
		end	
	end

  mo.previousx = mo.x
  mo.previousy = mo.y
  mo.previousz = mo.z
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	//if not (mo and mo.valid) then return end
	if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	
	if mobj.player.mun_dashstop
		if mobj.state == S_PHOENIX_SWIMCURL_A or mobj.state == S_PHOENIX_ADCURL_A or mobj.state == S_PHOENIX_SWIMCURL_B or mobj.state == S_PHOENIX_ADCURL_B
			mobj.state = S_PLAY_ROLL
			/*if not (mobj.eflags&MFE_UNDERWATER)
				if mobj.momz*P_MobjFlip(mobj) > -FRACUNIT*3
					mobj.state = S_PHOENIX_AIRDASH
					
					mobj.player.pflags = $|PF_SPINNING|PF_THOKKED


					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*2
						mobj.sprite2 = SPR2_FLY
					end
				
					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*8 and mobj.player.speed < 9*FRACUNIT
						mobj.sprite2 = SPR2_FIRE
					end
					mobj.frame = 0
				end
			else
				
				if mobj.momz*P_MobjFlip(mobj) > -FRACUNIT*3
					mobj.state = S_PHOENIX_SWIMDASH
				
					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*10
						mobj.sprite2 = SPR2_SPNG
					end
					mobj.frame = 0
				end
			end*/
		end
		mobj.player.pflags = $&~PF_THOKKED
		mobj.player.mun_dashstop = 0
		mobj.momz = $ * 4/7
		P_InstaThrust(mobj, R_PointToAngle2(0,0, mobj.momx, mobj.momy), min(mobj.player.speed, 36*FRACUNIT))
		return
	end
end)

addHook("MobjDeath", function(mo,mobj,src,dmgtype)
	//if not (mo and mo.valid) then return end
	if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) then return end
	//if not (mo.flags & MF_SHOOTABLE) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	
	if mobj.player.mun_dashstop
		if mobj.state == S_PHOENIX_SWIMCURL_A or mobj.state == S_PHOENIX_ADCURL_A or mobj.state == S_PHOENIX_SWIMCURL_B or mobj.state == S_PHOENIX_ADCURL_B
			mobj.state = S_PLAY_ROLL
			/*if not (mobj.eflags&MFE_UNDERWATER)
				if mobj.momz*P_MobjFlip(mobj) > -FRACUNIT*3
					mobj.state = S_PHOENIX_AIRDASH
					
					mobj.player.pflags = $|PF_SPINNING|PF_THOKKED


					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*2
						mobj.sprite2 = SPR2_FLY
					end
				
					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*8 and mobj.player.speed < 9*FRACUNIT
						mobj.sprite2 = SPR2_FIRE
					end
					mobj.frame = 0
				end
			else
				
				if mobj.momz*P_MobjFlip(mobj) > -FRACUNIT*3
					mobj.state = S_PHOENIX_SWIMDASH
				
					if mobj.momz*P_MobjFlip(mobj) >= FRACUNIT*10
						mobj.sprite2 = SPR2_SPNG
					end
					mobj.frame = 0
				end
			end*/
		end
		mobj.player.pflags = $&~PF_THOKKED
		mobj.player.mun_dashstop = 0
		mobj.momz = $ * 4/7
		P_InstaThrust(mobj, R_PointToAngle2(0,0, mobj.momx, mobj.momy), min(mobj.player.speed, 36*FRACUNIT))
		return
	end
end)

addHook("MobjMoveCollide", function(mo, other)
	if not mo or not mo.valid return end
	if not (mo.skin == SKIN) return end
	local player = mo.player
	if (player == nil) or (player.playerstate != PST_LIVE) return end
	if (not player.mun_dashstop) or (player.mun_dashstop <= 0) return end
	if (other.flags & MF_SOLID) and not (other.flags & MF_ENEMY or other.flags & MF_BOSS or other.flags & MF_MONITOR or other.flags & MF_PAIN) and not (other.type == MT_PLAYER)
		if (mo.z < other.z + other.height) and (mo.z + mo.height >= other.z)
			if (other.flags & MF_PUSHABLE)
				other.momx = $ + (mo.momx / 2)
				other.momy = $ + (mo.momy / 2)
				//other.momz = 3 * FRACUNIT
			end
			local wallnormangle = R_PointToAngle2(mo.x - mo.momx, mo.y - mo.momy, other.x, other.y)
			//DoWallBounce(mo,player,wallnormangle,false,0,1)
			P_InstaThrust(mo, wallnormangle, -5*FRACUNIT)
			S_StartSoundAtVolume(mo,sfx_bounc1,175)
			P_SetObjectMomZ(mo, max(FRACUNIT*6, FRACUNIT*4 + mo.momz*P_MobjFlip(mo)), false)
			player.mun_dashstop = 0
			player.mun_starthold = 0
			player.pflags = $|PF_STARTJUMP & ~PF_THOKKED
			return true
		end
	end
end, MT_PLAYER)

//local SKIN = "phoenix"

local TRANSITIONTIME = TICRATE * 3/6

/*local function ChecknBust(mo, sec, spinbust)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    if (fof.flags & FF_STRONGBUST) and (spinbust == true) continue end -- Is it too strong?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

   if (mo.player) and (mo.player.speed < mo.player.runspeed/3) continue end

    EV_CrumbleChain(fof) -- Crumble
  end
end*/

freeslot("S_PHOENIX_ADCURL_A", "S_PHOENIX_SWIMCURL_A", "S_PHOENIX_ADCURL_B", "S_PHOENIX_SWIMCURL_B", "S_DOTHATADLUA")

states[S_PHOENIX_ADCURL_A] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_ROLL|A,
		var1 = S_PHOENIX_ADCURL_B,
		var2 = 0,
		tics = 1,
		nextstate = S_PHOENIX_ADCURL_A
}

states[S_PHOENIX_SWIMCURL_A] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|FF_SPR2SUPER|SPR2_ROLL|A,
		var1 = S_PHOENIX_SWIMCURL_B,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_SWIMCURL_A
}

states[S_PHOENIX_ADCURL_B] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_ROLL|A,
		var1 = S_DOTHATADLUA,
		var2 = 0,
		tics = 1,
		nextstate = S_PHOENIX_ADCURL_B
}

states[S_PHOENIX_SWIMCURL_B] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|FF_SPR2SUPER|SPR2_ROLL|A,
		var1 = S_DOTHATADLUA,
		var2 = 0,
		tics = 2,
		nextstate = S_PHOENIX_SWIMCURL_B
}

states[S_DOTHATADLUA] = {
		sprite = SPR_PLAY,
		frame = SPR2_ROLL|C,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_DOTHATADLUA
}

freeslot("SKINCOLOR_THUNDEROVERLAY")
skincolors[SKINCOLOR_THUNDEROVERLAY] = {
	name = "ThunderOverlay",
	ramp = {130,130,130,130,131,131,131,131,132,133,135,135,135,136,136,137},
	accessible = false
}

/*addHook("AbilitySpecial", function(player)
 if player and player.mo and player.mo.valid
 and player.mo.skin == SKIN

  if player.dsp_batterydashst == 0
  and not ((player.pflags&PF_THOKKED)
  and not (player.mo.eflags&MFE_UNDERWATER)
  and (player.dschargestate ~= 1))
   player.dsp_batterydashst = 1
   player.mo.state = S_PLAY_SPINDASH
   player.pflags = $|PF_THOKKED
   player.dsp_batterydashti = TRANSITIONTIME
   player.powers[pw_strong] = STR_ANIM|STR_ATTACK
   return true
  end
 else
  return
 end
end)*/

addHook("PlayerThink", function(player)
 if player and player.mo and player.mo.valid
 and player.mo.skin == SKIN
  local mo = player.mo
  local p = player
  local skinvar = skins[player.mo.skin]

  player.truspeed = R_PointToDist2(0,0, player.rmomx, player.rmomy) or 0

  if player.dsp_batterydashst == nil or (player.playerstate == PST_REBORN)
   player.dsp_batterydashst = 0
   player.dsp_batterydashti = 0
  end

  player.dsp_batterydashti = max($-1, 0)

  if player.dsp_batterydashst == 1
   player.mo.momx = FixedMul($,85*FRACUNIT/90)
		player.mo.momy = FixedMul($,85*FRACUNIT/90)
		player.mo.momz = FixedMul($,78*FRACUNIT/90)

   if not player.dsp_batterydashti or (not (player.cmd.buttons&BT_JUMP) and player.dsp_batterydashti <= TICRATE/2) or player.mo.state ~= S_PLAY_SPINDASH
    local prevtime = max(player.dsp_batterydashti/3, 1)
    player.dsp_batterydashst = 0
    player.dsp_batterydashti = (player.mo.eflags&MFE_UNDERWATER) and 18 or 9

    if player.mo.state == S_PLAY_SPINDASH
			player.powers[pw_strong] = STR_ANIM|STR_BUST|STR_GUARD|STR_ATTACK
     player.mo.state = (mo.eflags&MFE_UNDERWATER) and S_PHOENIX_SWIMCURL or S_PHOENIX_ADCURL
     player.drawangle = player.mo.angle

     local dashspd = (player.mo.eflags&MFE_UNDERWATER) and FRACUNIT*36 or FRACUNIT*70
     player.slowit_speed = (player.powers[pw_sneakers] or player.powers[pw_super]) and player.truspeed*9/6 or max(player.normalspeed * 39/36, player.truspeed * 8/7) //lowest speed we wanna slow down to

     if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
     P_InstaThrust(player.mo, player.mo.angle, (player.mo.eflags&MFE_UNDERWATER) and max(player.truspeed, FixedMul(dashspd, player.mo.scale)) or max(player.truspeed + FRACUNIT*10, FixedMul(dashspd, player.mo.scale)))
     end

     P_SetObjectMomZ(player.mo, (player.mo.eflags&MFE_UNDERWATER) and (FRACUNIT*12/prevtime) or (FRACUNIT*27 / prevtime), false)

     //S_StartSound(player.mo, sfx_zoom)
     S_StartSound(player.mo, sfx_s3k45)
	   S_StartSound(player.mo, sfx_airdsh)
     player.dsp_batterydashst = 2
    end
   end
  end

  if player.dsp_batterydashst == 2
   if player.mo.state == S_PLAY_SPRING
			player.mun_dashstop = 0
			player.powers[pw_strong] = STR_NONE
			return
		end

		player.powers[pw_strong] = STR_ANIM|STR_BUST|STR_GUARD|STR_ATTACK

   /*if player.mo.state == S_PLAY_ROLL or player.mo.state == S_PHOENIX_ADCURL
		local t = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_THOK)
		t.color = SKINCOLOR_THUNDEROVERLAY //player.mo.color
		t.fuse = 4
		t.scale = player.mo.scale
		t.destscale = t.scale/2
		else*/
		local t = P_SpawnGhostMobj(player.mo)
		t.color = SKINCOLOR_THUNDEROVERLAY2 //player.mo.color
		t.scale = player.mo.scale
		t.fuse = 4
		t.colorized = true
		//end

		if player.mo.state == S_DOTHATADLUA
			player.mo.state = S_PLAY_ROLL
			if not (player.mo.eflags&MFE_UNDERWATER)
				if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
					player.mo.state = S_PHOENIX_AIRDASH
					
					player.pflags = $|PF_SPINNING|PF_THOKKED


					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*2
						player.mo.sprite2 = SPR2_FLY
					end
				
					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*8 and player.speed < 9*FRACUNIT
						player.mo.sprite2 = SPR2_FIRE
					end
					player.mo.frame = 0
				end
			else
				
				if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT*3
					player.mo.state = S_PHOENIX_SWIMDASH
				
					if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT*10
						player.mo.sprite2 = SPR2_JUMP
					end
					player.mo.frame = 0
				end
			end
   end

   if not player.dsp_batterydashti or (P_IsObjectOnGround(mo) or (mo.eflags&MFE_JUSTHITFLOOR))
    player.dsp_batterydashst = 0

    if player.dsp_batterydashti > 0
     player.dsp_batterydashti = 0
			player.powers[pw_strong] = STR_NONE
			ChecknBust(player.mo, player.mo.subsector.sector) 
     P_InstaThrust(player.mo, mo.angle, FixedMul(player.truspeed, mo.friction))
			
			if (player.cmd.buttons&BT_SPIN)
				player.pflags = $|PF_SPINNING & ~(PF_THOKKED)
				P_InstaThrust(player.mo, player.mo.angle, player.speed-player.thrustfactor)
				S_StartSound(player.mo,sfx_zoom)
				player.mo.state = S_PLAY_ROLL
			else
				if ((player.pflags&PF_STARTJUMP) or (player.cmd.buttons&BT_JUMP))
					S_StartSound(player.mo, sfx_boingf)
					P_SetObjectMomZ(player.mo, (player.mo.eflags&MFE_UNDERWATER) and FixedMul(5*FRACUNIT, player.mo.scale) or FixedMul(9*FRACUNIT, player.mo.scale))
				end
				player.mo.momx = $ - $/6
				player.mo.momy = $ - $/6
				
				player.pflags = ((player.pflags&PF_STARTJUMP) or (player.cmd.buttons&BT_JUMP)) and $|PF_JUMPED|PF_STARTJUMP & ~(PF_SPINNING|PF_THOKKED) or $|PF_JUMPED|PF_STARTJUMP|PF_THOKKED & ~(PF_SPINNING)
				P_InstaThrust(player.mo, player.mo.angle, player.speed-player.thrustfactor)
				S_StartSoundAtVolume(player.mo,sfx_bounc1,175)
				P_SetObjectMomZ(player.mo, max(FRACUNIT*6, FRACUNIT*4 + player.mo.momz*P_MobjFlip(player.mo)), false)
				player.mo.state = S_PLAY_ROLL
     end
    else
     player.powers[pw_strong] = $ & ~(STR_GUARD|STR_BUST|STR_SPIKE)
    end
    player.slowit_speed = 0
    return
   end

   if player.dsp_batterydashti <= 5 and player.dsp_batterydashti >= 3
			
			if player.truspeed > player.slowit_speed
				player.mo.momx = (player.mo.eflags&MFE_UNDERWATER) and $ - $/9 or $ - $/7
				player.mo.momy = (player.mo.eflags&MFE_UNDERWATER) and $ - $/9 or $ - $/7
			end

    if player.mo.momz*P_MobjFlip(player.mo) > -FRACUNIT and not (player.mo.eflags&MFE_UNDERWATER)
			player.mo.momz = (player.mo.eflags&MFE_UNDERWATER) and $ - $/6 or $ - $/4 //- P_GetMobjGravity(player.mo)
			end
    end
  end
 else
  return
 end
end)

addHook("MobjDamage", function(mo,mobj,src,dmg,dmgtype)
	//if not (mo and mo.valid) then return end
	if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	local player = mobj.player
	
	if (player.dsp_batterydashti) and (player.dsp_batterydashst == 2)
		mobj.player.pflags = $&~PF_THOKKED
	  //mobj.momz = $ * 4/7
		return
	end
end)

addHook("MobjDeath", function(mo,mobj,src,dmgtype)
	//if not (mo and mo.valid) then return end
	if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)) then return end
	//if not (mo.flags & MF_SHOOTABLE) then return end
	
	if not (mobj and mobj.valid) then return end
	if not (mobj.player and mobj.player.valid) then return end
	local player = mobj.player

	if (player.dsp_batterydashti) and (player.dsp_batterydashst == 2)
		mobj.player.pflags = $&~PF_THOKKED
		//mobj.momz = $ * 4/7
		return
	end
end)

addHook("MobjMoveCollide", function(mo, other)
	if not mo or not mo.valid return end
	if not (mo.skin == SKIN) return end
	local player = mo.player
	if (player == nil) or (player.playerstate != PST_LIVE) return end
	if (not player.dsp_batterydashti) or (player.dsp_batterydashti <= 0) or (player.dsp_batterydashst ~= 2) return end
	if (other.flags & MF_SOLID) and not (other.flags & MF_ENEMY or other.flags & MF_BOSS or other.flags & MF_MONITOR or other.flags & MF_PAIN) and not (other.type == MT_PLAYER)
		if (mo.z < other.z + other.height) and (mo.z + mo.height >= other.z)
			if (other.flags & MF_PUSHABLE)
				other.momx = $ + (mo.momx / 2)
				other.momy = $ + (mo.momy / 2)
				//other.momz = 3 * FRACUNIT
			end
			local wallnormangle = R_PointToAngle2(mo.x - mo.momx, mo.y - mo.momy, other.x, other.y)
			//DoWallBounce(mo,player,wallnormangle,false,0,1)
			P_InstaThrust(mo, wallnormangle, -5*FRACUNIT)
			S_StartSoundAtVolume(mo,sfx_bounc1,175)
			P_SetObjectMomZ(mo, max(FRACUNIT*6, FRACUNIT*4 + mo.momz*P_MobjFlip(mo)), false)
			player.dsp_batterydashst = 0
			player.dsp_batterydashti = 0
			player.pflags = $|PF_STARTJUMP & ~PF_THOKKED
			return true
		end
	end
end, MT_PLAYER)