local SKIN = "phoenix"
local THOKTIME = 7

--FixedLerp
local function FixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

//kick ass thok
addHook("AbilitySpecial", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if not (player.pflags&PF_THOKKED) and not (player.pflags&PF_JUMPDOWN)
  and (player.thiscoolthokihave ~= nil and player.thiscoolthokihave.state == 0)
   player.thiscoolthokihave.state = 1
   player.thiscoolthokihave.time = 0
   player.canelectronrush = true

   player.mo.state = S_PLAY_ROLL
   player.pflags = $|PF_THOKKED|PF_STARTJUMP
   player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPRING
   return true
  end
 else
  return
 end
end)

addHook("JumpSpecial", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  if player.thiscoolthokihave == nil then return end
  local thoktable = player.thiscoolthokihave

  if thoktable.cantrick == false or (player.pflags&PF_JUMPDOWN) or (player.gotflag) then return end
  
  if not (P_IsObjectOnGround(player.mo)) and not (player.pflags&PF_STASIS)
  and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL
  or S_PLAY_MID_FALL ~= nil and player.mo.state == S_PLAY_MID_FALL)
  and not player.exiting
   thoktable.cantrick = false
   S_StartSound(player.mo, sfx_zoom)

   if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
    //print("trick in a cool direction")
    local ang, factorA, factorB = (player.cmd.angleturn<<16) + R_PointToAngle2(0,0, player.cmd.forwardmove<<16, -(player.cmd.sidemove<<16)), min(FRACUNIT, max(R_PointToDist2(0,0, player.cmd.forwardmove*FRACUNIT, player.cmd.sidemove*FRACUNIT)/48, 0))
    factorB = FRACUNIT-factorA

    
    P_InstaThrust(player.mo, ang, max(FixedMul(factorA, FRACUNIT*40), player.speed + FixedMul(factorA, FRACUNIT*12)))
    P_SetObjectMomZ(player.mo, max(FRACUNIT*6, max(FixedMul(factorB, FRACUNIT*10), player.mo.momz*P_MobjFlip(player.mo)/2)), false)
    player.mo.state = S_PHOENIX_HUMMINGTOP
   else
    //print("trick up")

    P_SetObjectMomZ(player.mo, FRACUNIT*20)
    player.mo.state = S_PHOENIX_YAY
    player.panim = PA_SPRING
   end

   player.pflags = $|PF_JUMPED|PF_THOKKED & ~(PF_SPINNING)
   if (player.ds_electronrush ~= nil)
    player.canelectronrush = true
   end
   return true
  end
 else
  return
 end
end)

addHook("PlayerThink", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  if player.thiscoolthokihave == nil
   player.thiscoolthokihave = {}

   player.thiscoolthokihave.state = 0
   player.thiscoolthokihave.time = 0
  end

  local thoktable = player.thiscoolthokihave

 
 if (player.mo.eflags & MFE_SPRUNG) or player.powers[pw_justsprung] or player.powers[pw_carry] == CR_FAN or not (player.pflags&PF_JUMPED) or player.powers[pw_carry] == CR_DUSTDEVIL
  thoktable.cantrick = true
 end
 if P_IsObjectOnGround(player.mo) or (player.pflags&PF_THOKKED)
  thoktable.cantrick = false
 end


  if thoktable.state == 1 //charge it
   if ((player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) or P_PlayerInPain(player) or (player.powers[pw_carry]) or player.mo.state ~= S_PLAY_ROLL or (player.mo.eflags&MFE_SPRUNG)
    thoktable.state = 0
    thoktable.time = 0
    
    if ((player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) and not P_PlayerInPain(player) //and player.speed > FRACUNIT
     player.pflags = $|PF_SPINNING & ~PF_THOKKED
     player.mo.state = S_PLAY_ROLL
     S_StartSound(player.mo, sfx_zoom)
     P_InstaThrust(player.mo, player.mo.angle, player.speed + FRACUNIT*(thoktable.time+3))
    end
    return
   end

   //if thoktable.time
    thoktable.time = max(0, $+1)
    P_SetObjectMomZ(player.mo, max(player.mo.momz*P_MobjFlip(player.mo) * 95/100, -FRACUNIT*18), false)
    player.mo.state = S_PLAY_ROLL
   //end

   if thoktable.time >= THOKTIME or not (player.cmd.buttons&BT_JUMP)
    thoktable.state = 2
    player.pflags = $|PF_THOKKED|PF_STARTJUMP

    local dashspd = (player.mo.eflags&MFE_UNDERWATER) and FRACUNIT*30 or 39*FRACUNIT
    
    if player.powers[pw_super] or player.powers[pw_sneakers]
     dashspd = $*4/3
    end
    

    if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
    P_InstaThrust(player.mo, player.mo.angle, max(player.speed, FixedMul(dashspd, player.mo.scale)))
    



    if thoktable.time > 5
     player.mo.momz = FixedMul(player.mo.momz, FixedDiv(THOKTIME - thoktable.time, THOKTIME)) --divide zmomentum

    //P_SetObjectMomZ(player.mo, FRACUNIT*4, true)

     if player.speed <= FixedMul(FRACUNIT*60, dashspd/40)
     P_Thrust(player.mo, player.mo.angle, FRACUNIT*(thoktable.time+3) * 3/5) --xtra speed
     end

     player.pflags = $|PF_SPINNING|PF_THOKKED
     S_StartSound(player.mo, sfx_s3k45)
     S_StartSound(player.mo, sfx_zoom)
    end

     else //if not (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
      P_SetObjectMomZ(player.mo, FRACUNIT*13)
	  if player.powers[pw_super] then player.mo.momz = $*4/3 end
      player.pflags = $|PF_SPINNING|PF_THOKKED
      S_StartSound(player.mo, sfx_zoom)
      S_StartSound(player.mo, sfx_s3k45)
      //player.mo.momx = $*5/9
      //player.mo.momy = $*5/9
     end
    
    player.mo.state = S_PLAY_ROLL
    P_SpawnThokMobj(player)
    S_StartSound(player.mo, sfx_thok)
    thoktable.time = $*3
    thoktable.angle = player.mo.angle
    player.drawangle = player.mo.angle
    player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPRING
   end
  end

  if thoktable.state == 2 //actually in the thok
   if ((player.mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)) or P_PlayerInPain(player) or (player.powers[pw_carry]) or player.mo.state ~= S_PLAY_ROLL or (player.mo.eflags&MFE_SPRUNG) or not thoktable.time
    thoktable.state = 0
    player.powers[pw_strong] = STR_NONE
    return
   end

   if thoktable.time
    thoktable.time = max(0, $-1)
    
    if not (player.pflags&PF_JUMPDOWN) and not (player.cmd.buttons&BT_JUMP)
     thoktable.time = max(0, $-1)
    end

    if thoktable.time > 12 or (player.pflags&PF_SPINNING) and thoktable.time > 8
     //P_SpawnThokMobj(player)
     /*local thokmobj = P_SpawnMobjFromMobj(player.mo, player.mo.momx, player.mo.momy, player.mo.momz-player.height/4, MT_THOK)
     thokmobj.scale = player.mo.scale*4/3
     thokmobj.destscale = player.mo.scale/4
     thokmobj.destspeed = FRACUNIT/2
     thokmobj.color = player.mo.color*/

local mo = player.mo
    for i = 0, 10
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(mo)
				local tx = FixedLerp(mo.x+player.mo.momx*2,mo.previousx ,percent)
				local ty = FixedLerp(mo.y+player.mo.momy*2,mo.previousy,percent)
				local tz = FixedLerp(mo.z+player.mo.momz*2 + 3*FRACUNIT,mo.previousz + 4*FRACUNIT,percent)
				P_MoveOrigin(trail, tx, ty, tz - 16 * FRACUNIT)
				trail.fuse = 13
				trail.state = S_THOK
				trail.scalespeed = FRACUNIT/8
				trail.scale = (FRACUNIT * 9/7) - (i * FRACUNIT/140)
				trail.destscale = 0
				trail.frame = TR_TRANS70|A
		   //trail.color = SKINCOLOR_THUNDEROVERLAY

       if trail.state ~= S_THOK
       trail.colorized = true
       end
				//trail.color = SKINCOLOR_BLUE
			end

     P_SetObjectMomZ(player.mo, -(P_MobjFlip(player.mo)*P_GetMobjGravity(player.mo)) * 3/5, true)
    end

    player.drawangle = thoktable.angle
    player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_SPRING
   end
  end

  player.mo.previousx = player.mo.x
  player.mo.previousy = player.mo.y
  player.mo.previousz = player.mo.z
 else
  return
 end
end)

//hook reused from juniosonic

addHook("MobjDeath", function(enemy, freedom, freedom)
	if (freedom and freedom.valid) and freedom.skin == SKIN and (freedom.player)
	 if freedom.player.thiscoolthokihave == nil then return end
		if (enemy and enemy.valid)
		and (enemy.flags & MF_ENEMY or enemy.flags & MF_MONITOR or enemy.flags & MF_SHOOTABLE) and not (enemy.flags & MF_BOSS)
			if freedom.player.thiscoolthokihave.state > 0
				freedom.player.thiscoolthokihave.state = 0
				
      if (freedom.player.pflags&PF_JUMPDOWN)
		    P_SetObjectMomZ(freedom, max(max(freedom.momz*P_MobjFlip(freedom)*-1, freedom.momz*P_MobjFlip(freedom)), FRACUNIT*12), false)
      end
			end

     if (freedom.state == S_PLAY_JUMP or freedom.state == S_PLAY_ROLL) and (freedom.player.pflags&PF_JUMPED) or (freedom.player.ds_electronrush ~= nil and freedom.player.ds_electronrush.state == 4 and freedom.state == S_PHOENIX_BATTWIN)
      freedom.player.pflags = $1 & ~(PF_THOKKED|PF_SPINNING)
	  
	  if freedom.player.ds_electronrush
		freedom.player.ds_electronrush.isdropdash = false
		
	    if freedom.player.ds_electronrush.state == 4 and not P_IsObjectOnGround(freedom)
			freedom.player.ds_electronrush.state = 0
			freedom.state = S_PLAY_ROLL
		end
	  end
     end
		end
		return false
	end
end)

addHook("MobjDamage", function(phoenix, _, _, dmg, type)
 if phoenix and phoenix.valid and phoenix.player and phoenix.skin == SKIN and not phoenix.player.gotflag and not (CBW_Battle)
  if dmg and type ~= DMG_ELECTRIC then return end

  phoenix.player.powers[pw_flashing] = 1
  return true
 else return
 end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mo, other)
	if not mo or not mo.valid return end
	if not (mo.skin == SKIN) return end
	local player = mo.player
	if (player == nil) or (player.playerstate != PST_LIVE) return end
	if (player.thiscoolthokihave.state ~= 2) return end
	if (other.flags & MF_SOLID) and not (other.flags & MF_BOSS or other.flags & MF_MONITOR or other.flags & MF_PAIN) and not (other.type == MT_PLAYER) or (other.flags&MF_PUSHABLE)
		if (mo.z < other.z + other.height) and (mo.z + mo.height >= other.z)
			if (other.flags & MF_PUSHABLE)
				other.momx = $ + (mo.momx * 2 / 3)
				other.momy = $ + (mo.momy * 2 / 3)
				//other.momz = 3 * FRACUNIT
			end
			local wallnormangle = R_PointToAngle2(mo.x - mo.momx, mo.y - mo.momy, other.x, other.y)
			//DoWallBounce(mo,player,wallnormangle,false,0,1)
			P_InstaThrust(mo, wallnormangle, -5*FRACUNIT)
			//S_StartSoundAtVolume(mo, sfx_bounc1,175)
			P_SetObjectMomZ(mo, (player.homingdash) and FRACUNIT*6 or max(FRACUNIT*6, FRACUNIT*4 + mo.momz*P_MobjFlip(mo)), false)
			player.thiscoolthokihave.state = 0
     player.thiscoolthokihave.time = 0
     //player.homingdash = 0
			player.pflags = $|PF_STARTJUMP & ~PF_THOKKED
			return true
		end
	end
end, MT_PLAYER)